# $Id: printing.py 30 2006-02-20 23:57:51Z psanchez $
#
# Copyright 2005, Pedro I. Sanchez (psanchez@colcan.biz)
#
#     This computer program is released under the
#         GNU GENERAL PUBLIC LICENSE Version 2
#              (See the file COPYING)
#

import os

MT_VERSION = '0.3'
LPR_COMMAND = 'lpr'
ENSCRIPT_COMMAND= 'enscript --font="Courier-Bold@14" --header="Name:||MathTables v%s -- Page $%% of $=" --borders --media=letter --quiet --output=-' % MT_VERSION


class PrintMTError(Exception):
    def __init__(self, errcode, errmsg=None):
        if errmsg is None:
            errmsg = 'Unknown error.'
        Exception.__init__(self,
                           'error %s: %s' % (errcode, errmsg))

def _print(doc, lpr_command):
    command = lpr_command+'|'+LPR_COMMAND
    p = os.popen(command,'w')
    p.write(doc)
    r = p.close()
    if r is None:
        return 'Math table print job submitted to the default printer.'
    else:
        command = lpr_command.split(' ')[0]
        r = r >> 8
        if  r == 127:
            msg = '%s not found ... ' % command
            raise PrintMTError(r, msg)
        else:
            raise PrintMTError(r)

def pretty_print(doc, cell_height):
    msg = ''
    try:
        msg += _print(doc, ENSCRIPT_COMMAND)
        return msg
    except PrintMTError, e:
        msg += '%s ' % e
        try:
            msg += _print(doc, LPR_COMMAND)
            return msg
        except PrintMTError, e:
            msg += '%s ' % e
            return msg+'Print operation failed.'
